{Hint: save all files to location: J:\!work\FPC\TestView\jni }
unit uMain;

{$mode delphi}

interface

uses
  {$IFDEF UNIX}{$IFDEF UseCThreads}
  cthreads,
  {$ENDIF}{$ENDIF}
  Classes, SysUtils, AndroidWidget, Laz_And_Controls, paintshader, And_jni;
  
type

  { TAndroidModule1 }

  TAndroidModule1 = class(jForm)
    jBitmap1: jBitmap;
    jCanvas1: jCanvas;
    jPaintShader1: jPaintShader;
    jView1: jView;
    procedure AndroidModule1ActivityResult(Sender: TObject;
      requestCode: integer; resultCode: TAndroidResult; intentData: jObject);
    procedure AndroidModule1JNIPrompt(Sender: TObject);
    procedure AndroidModule1Show(Sender: TObject);
    procedure jView1Draw(Sender: TObject);
  private
    Screen: TWH;
    half: TPoint;
    rad: Integer;
    bg, surf, sh1, sh2, sh3, planet: Integer;
  public
    {public declarations}
  end;

var
  AndroidModule1: TAndroidModule1;

implementation
  
{$R *.lfm}
  

{ TAndroidModule1 }

procedure TAndroidModule1.AndroidModule1JNIPrompt(Sender: TObject);
begin
  // disable hardware acceleration for the `JPaintShader.Combine` method to work correctly !
  jView1.SetLayerType(ltSOFTWARE); // need VERSION.SDK_INT >= 11

  // set manually ID
  sh3 := 3;
  surf := 4;
  planet := 5;

  jBitmap1.ImageIdentifier := 'sky2';
  // background
  bg := jView1.Canvas.PaintShader.NewBitmapShader(jBitmap1.GetImage, tmREPEAT, tmREPEAT, 1.2, 1.2, 45);
  // planet surface
  sh1 := jView1.Canvas.PaintShader.NewSweepGradient(120, 50, [$FFFF0707, $FFFF6A07, {$FFFFD507, $FFB8FF07, $FF51FF07,} $FF07FF24, $FF07FF8F,
                                                             $FF07FFFF, $FF0797FF, $FF072CFF, $FF4907FF, $FFB007FF, $FFFF07DE{, $FFFF0772}], []);
  jBitmap1.ImageIdentifier := 'surf';
  sh2 := jView1.Canvas.PaintShader.NewBitmapShader(jBitmap1.GetImage, tmREPEAT, tmREPEAT);
  jView1.Canvas.PaintShader.Combine(sh2, sh1, PorterDuff.OVERLAY, surf);
end;

procedure TAndroidModule1.AndroidModule1Show(Sender: TObject);
begin
  Screen := Self.ScreenWH;
  half.X := Screen.Width div 2;
  half.Y := Screen.Height div 2;
  rad := half.X div 2;
end;

procedure TAndroidModule1.AndroidModule1ActivityResult(Sender: TObject;
  requestCode: integer; resultCode: TAndroidResult; intentData: jObject);
begin

end;

procedure TAndroidModule1.jView1Draw(Sender: TObject);
begin
  jView1.Canvas.Clear($FFFFFFFF);
  jView1.Canvas.PaintStyle := psDEFAULT;
  // draw space
  jView1.Canvas.PaintShader.Bind(bg);
  jView1.Canvas.DrawRect(0, 0, Screen.Width, Screen.Height);
  jView1.Canvas.DrawText('Star Space!', 100, 100);

  jView1.Canvas.PaintShader.SetIdentity(surf);

  // atmosphere & fog
  jView1.Canvas.PaintShader.NewRadialGradient(half.X + 80, half.Y div 2, rad + 100, $CC000000, $FFFFFFFF, tmCLAMP, sh3);
  jView1.Canvas.PaintShader.Combine(surf, sh3, PorterDuff.ADD, planet);
  // draw planet
  jView1.Canvas.PaintShader.Bind(planet);
  jView1.Canvas.DrawCircle(half.X + 100, half.Y div 2, rad);

  // atmosphere
  jView1.Canvas.PaintShader.SetScale(0.7, 0.7, surf);
  jView1.Canvas.PaintShader.SetRotate(-35, surf);
  jView1.Canvas.PaintShader.NewRadialGradient(half.X - 120, Screen.Height - (half.Y div 2), rad + 30, $CC0000CC, $FFCCFFCF, tmCLAMP, sh3);
  jView1.Canvas.PaintShader.Combine(surf, sh3, PorterDuff.MULTIPLY, planet);
  // draw small planet
  jView1.Canvas.PaintShader.Bind(planet);
  jView1.Canvas.DrawCircle(half.X - 100, Screen.Height - (half.Y div 2), rad - 50);

  // draw ufo
  jBitmap1.ImageIdentifier := 'ufo';
  jView1.Canvas.DrawFrame(jBitmap1.GetImage, 0, 0, jBitmap1.Width, jBitmap1.Height, half.X, half.Y - 50, jBitmap1.Width, jBitmap1.Height, -15);
end;


end.
